/*
	LED banner - An LED Banner Display
	Copyright © 2006-2007 Edward Barnett and Harry Whitfield

	This program is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the
	Free Software Foundation; either version 2 of the License, or (at your
	option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; if not, write to the Free Software Foundation, Inc.,
	51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

	LED Banner - version 2.0
	23 March, 2007
	Copyright © 2006 Edward Barnett and Harry Whitfield
	mailto:g6auc@arrl.net
*/

function scrape(subItem, data, startStr, endStr, prefixStr, suffixStr, guardStr, noCaseMode, globalMode)
{
	function escapeChar(s) { return s.replace(/([\W])/g,"\\$1"); }

	var frontStr  = prefixStr + startStr;
	var backStr   = endStr + suffixStr;

	if ((frontStr !== "") && (backStr !== ""))
	{
		var guard   = escapeChar(guardStr);
		var start   = escapeChar(prefixStr + startStr);
		var	finish  = escapeChar(endStr + suffixStr);
		var lookFor = start + '([.\\s\\S]*?)' + finish;
		var pattern;
		if (globalMode)
		{
			if (noCaseMode) { pattern = new RegExp(lookFor, "gi"); } else { pattern = new RegExp(lookFor, "g"); }
		}
		else
		{
			if (guardStr   !== "") { lookFor = guard + '[.\\s\\S]*?' + lookFor; }
			if (noCaseMode)		   { pattern = new RegExp(lookFor, "i"); } else { pattern = new RegExp(lookFor); }
		}
		var found = data.match(pattern);
		if (found !== null)
		{
			var text = [];
			if (globalMode)
			{
				for (var i = 0; i < found.length; i += 1)
				{
					var idx = found[i].length - suffixStr.length;
					text[i] = found[i].substring(prefixStr.length, idx);
				}
			}
			else	// just one text
			{
				text[0] = startStr + found[1] + endStr;
			}
			return text;
		}
		else if (preferences.alertPref.value != "0")
		{
			eprint('scrape: nothing was found for ' + subItem);
			beep();
			 alert('scrape: nothing was found for ' + subItem);
		}
	}
	else
	{
		eprint('scrape: incorrect parameters.');
		beep();
		 alert('scrape: incorrect parameters.');
	}
	return null;
}

/*
<item>
<title>Competition</title>
<link>http://www.bbc.co.uk/worldservice/learningenglish/competition.shtml</link>
<description>See the winning entries in our most recent competitions.</description>
<pubDate>Mon, 16 Oct 2006 08:45:26 GMT</pubDate>
</item>
*/

var rssData;

function min(a, b) { if (b < a) { return b; } return a; }

function getRSSdata(entry)
{
	var theText = "";
	rssData = takeAction(entry);
	
/*	
	for (var i = 0; i < 10; i=i+1)
	{
		if (rssData === undefined) { sleep(1000); }
	}
*/
	if (rssData !== null)
	{
		var itemArr = scrape('item', rssData, '<item>', '</item>', '', '', '', true, true);
		if (itemArr !== null)
		{
			for (var i = 0; i < min(itemArr.length, maxRssItems); i=i+1)
			{
				var title = scrape('title[' + i + ']', itemArr[i], '', '', '<title>', '</title>', '', true, false);
				//var link  = scrape('link[' + i + ']', itemArr[i], '', '', '<link>', '</link>', '', true, false);
				var description  = scrape('description[' + i + ']', itemArr[i], '', '', '<description>', '</description>', '', true, false);
				//var pubDate  = scrape('pubDate[' + i + ']', itemArr[i], '', '', '<pubDate>', '</pubDate>', '', true, false);
			
				if (showTitlesOnly)
				{
					if (title !== null) { theText += title + ' :: '; }
				}
				else
				{
					if (title !== null)
					{
						theText += title;
						if (description !== null) { theText += ': ' + description; }
						theText += ' :: ';
					}
				}
			}
		}
		theText = deEnt(deEnt(theText));
		theText = theText.replace(/<br \/>/gi, "\n").replace(/<\!\-\-.*?\-\->/g, '').replace(/<div class\=.*?>/gi, '');
		theText = theText.replace(/<\/div>/gi, '').replace(/<\w>/g, '').replace(/<\/\w>/g, '').replace(/<img .*?(\/>|><\/img>)/gi, '');
		theText = theText.replace(/<a .*?>/gi, '').replace(/\[snapback\].*?\[\/snapback\]/gi, '');
		
		if (removeCDATAtags) { theText = theText.replace(/<\!\[CDATA\[/g, '').replace(/\]\]>/g, ''); }

		return theText;
	}
	else if (preferences.alertPref.value != "0")
	{
		eprint('getRSSdata: takeAction failed.');
		beep();
		alert('getRSSdata: takeAction failed.');
	}
	return null;
}


