/*
	RSSfeeds - RSS feeds dictionary module
	Copyright © 2004-2007 Harry Whitfield and Ricky Romero

	This program is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the
	Free Software Foundation; either version 2 of the License, or (at your
	option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; if not, write to the Free Software Foundation, Inc.,
	51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
	
	RSSfeeds - version 1.2
	7 August, 2007
	Copyright © 2004-2007 Harry Whitfield and Ricky Romero
	mailto:g6auc@arrl.net

*/

		var gQuickMax = Number(preferences.quickPref.value);	// Number of lines in the Choose Location Mnnu
		var quickMenu = null;
		var nextNumber = 0;
		var resPath = resolvePath('.');
		
		var locationDir = preferences.savedDirPref.value.split(",");	// build the directory etc.
		locationDir = locationDir.sort();
		var locationDefault = preferences.savedDefaultPref.value;
		var locationNum = locationDefault;
		
		var n = 0;				// general use
		var imageToggle = 0;	// cycles from 0 to 999,999 and round again.

		var MacOSXVersion = 0x1030;	// Mac OS X 10.3 = 0x1030 = 4144
		var Referer = "";
		
		var gImageEntry;		// used by CURL method

		function savePrefs(save)
		{
			if (save)
			{
				var folderPath = preferences.backupFolderPref.value;
				if ( savePlist(folderPath, widgetName) )
				{
					beep(); 
					alert('Saved preferences file as: ' + folderPath + '/' + widgetName + '.plist');
				}
				else 
				{
					beep();
					alert('Could not save preferences file as: ' + folderPath + '/' + widgetName + '.plist');
				}
				return;
			}
			else
			{
				beep();
				var res = alert("CAUTION: You are about to overwrite the widget's preferences.", 'Proceed', 'Cancel');
				if (res == 2) { return; }

				folderPath = preferences.backupFolderPref.value;
				if ( restorePlist(folderPath, widgetName) )
				{
					reloadWidget();
				}
				else 
				{
					beep();
					alert('Could not find preferences file: ' + folderPath + '/' + widgetName + '.plist');
				}
				return;
			}
		}


		function addMouseUp(edit)
		{
			var preload = "";
			
			if (edit) { preload = locationDefault; }
			
			while (true)
			{
			
				var tempLocationNum = addLocationData(preload);	// Add location number to locationbook
	
				if (tempLocationNum !== "")
				{
					var shortDir = nameDir(locationDir);
					var shortName = extractName(tempLocationNum);
					
					var n = findNumber(shortName,shortDir);
					if ( n >= 0)
					{
						beep();
						var answer = alert('An entry named ' + shortName + ' already exists. Do you want to replace it with the one you are saving?', "Cancel", "Replace");
						eprint('addMouseUp:An entry named ' + shortName + ' already existed. The answer was ' + answer);
						if (answer == 1) { preload = tempLocationNum; continue; }
					}
	
					locationNum = tempLocationNum;
					locationDefault = locationNum;
					if (n  < 0 ) { n = locationDir.length; }
					locationDir[n] = locationNum;
					locationDir = locationDir.sort();
					preferences.savedDirPref.value = locationDir.join(",");
					preferences.savedDefaultPref.value = locationDefault;
					savePreferences();
					//writePlist("");
	
					if (n < 0) { eprint("addMouseUp:Added:" + locationNum); } else { eprint("addMouseUp:Replaced:" + locationNum); }
	
 					var menuStringsArray = nameDir(locationDir).join(',').split(',', gQuickMax);	// define the new array of menuStrings
					var selectedString   = chooseMenu.selected;  									// define the initially selected string, or set to ""
					chooseMenu.reset(menuStringsArray, selectedString);
				}
				break;
			}
		}

		function openMouseUp(browser)
		{
			if (browser)
			{
				var primaryURL = extractNum(locationNum);
				openURL(primaryURL);
				return;
			}
			else
			{
				var tempLocationNum = getLocationNumber(locationDir,locationDefault);	// Choose location number from locationbook

				if (tempLocationNum !== "")
				{
					locationNum = tempLocationNum;
					locationDefault = locationNum;
					preferences.savedDefaultPref.value = locationDefault;
					savePreferences();
					//writePlist("");
					nextNumber = findNumber(locationNum,locationDir);
					chooseMenu.setTick(nameDir(locationDir)[nextNumber]);
					reloadRSS();
				}
				return;
			}
		}

		function wrenchMouseUp(save)
		{
			if (save)
			{
				//saveImage();
				return;
			}

			var tempLocationNum = deleteLocationNumber(locationDir,locationDefault);	// Delete location number from locationbook
			
			if (tempLocationNum !== "")
			{
				locationNum = tempLocationNum;

				var n = findNumber(locationNum,locationDir);
				if (n >= 0)
				{
					locationDir[n] ="";
					locationDefault = "";
					eprint("wrenchMouseUp:Deleted:" + locationNum);
					locationDir = conflateDir(locationDir);
					if (locationDir.length === 0)		// If locationbook is empty
					{
						beep();
						locationNum = "Konfabulator Forums | http://www2.konfabulator.com/forums/rss.php";
						
						locationDir[0] = locationNum;		// Replace default number
						locationDefault = locationNum;
					}
					preferences.savedDirPref.value = locationDir.join(",");
					preferences.savedDefaultPref.value = locationDefault;
					savePreferences();
					//writePlist("");

					var menuStringsArray = nameDir(locationDir).join(',').split(',', gQuickMax);	// define the new array of menuStrings
					var selectedString   = "";  													// define the initially selected string, or set to ""
					chooseMenu.reset(menuStringsArray, selectedString);
				}
				else
				{
					beep();
					alert('Directory inconsistency.');
					eprint('wrenchMouseUp:Directory inconsistency.');
				}
			}
		}

		function extractName(locationNum)
		{
			var locationArr = locationNum.split(' | ');
			return locationArr[0];			
		}

		function extractNum(locationNum)
		{
			var locationArr = locationNum.split(' | ');
			return locationArr[1];			
		}

		function extractStartStr(locationNum)
		{
			var locationArr = locationNum.split(' | ');
			var value = locationArr[2];
			if (value !== undefined) { return value; }
			return "";
		}

		function extractEndStr(locationNum)
		{
			var locationArr = locationNum.split(' | ');
			var value = locationArr[3];
			if (value !== undefined) { return value; }
			return "";
		}

		function extractPrefixStr(locationNum)
		{
			var locationArr = locationNum.split(' | ');
			var value = locationArr[4];
			if (value !== undefined) { return value; }
			return "";
		}

		function extractSuffixStr(locationNum)
		{
			var locationArr = locationNum.split(' | ');
			var value = locationArr[5];
			if (value !== undefined) { return value; }
			return "";
		}

		function extractGuardStr(locationNum)
		{
			var locationArr = locationNum.split(' | ');
			var value = locationArr[6];
			if (value !== undefined) { return value; }
			return "";
		}
		
		function extractTextMode(locationNum)
		{
			var locationArr = locationNum.split(' | ');
			var value = locationArr[7];
			if (value !== undefined) { return value; }
			return "0";
		}

		function substBarAndComma(theNumber)
		{
		  	// replace all vertical bars and comma characters with %7C and %2C respectively
		
		  	temp = "";
		  	for (count = 0; count < theNumber.length; count += 1)
		  	{
		  		if (theNumber[count] == "|") { temp += "%7C"; } else
		  		if (theNumber[count] == ",") { temp += "%2C"; } else
		  		{ temp += theNumber[count]; }
		  	}
		  	return temp;
		}

		function stripBarAndComma(theNumber)
		{
		  	// remove all vertical bars and comma characters
		
		  	temp = "";
		  	for (count = 0; count < theNumber.length; count += 1)
		  	{
		  		if  ((theNumber[count] != "|") && (theNumber[count] != ",")) { temp += theNumber[count]; }
		  	}
		  	return temp;
		}

		function conflateDir(locationDir)
		{
			var result = [];
			var m = 0;
			
			var n = locationDir.length;
			for (var i = 0; i < n; i += 1)
			{
				if (locationDir[i] !== "") { result[m] = locationDir[i]; m += 1; }
			}
			return result;
		}

		function printDirectory(locationDir)
		{
			var n = locationDir.length;
			eprint("-----------Directory-----------");
			for (var i = 0; i < n; i += 1)
			{
				if (locationDir[i] !== "") { eprint(locationDir[i]); }
			}
		}

		function nameDir(locationDir)
		{
			var result = [];
			var n = locationDir.length;
			for (var i = 0; i < n; i += 1)
			{
				result[i] = extractName(locationDir[i]);
			}
			return result;
		}

		function findNumber(locationNum,locationDir)
		{
			var n = locationDir.length;
			for (var i = 0; i < n; i += 1)
			{
				if (locationDir[i] == locationNum) { return i; }
			}
			return -1;
		}

		function getLocationNumber(locationDir,locationDefault)
		{
			var shortDir = nameDir(locationDir);
			
			var objDef = [];
			
			objDef[0] = ['entries','RSS Locations:','popup',shortDir,extractName(locationDefault),'Select an RSS location.'];

			var formfields = [];
			var i = 0;
			var n = 1;
			
			for (i = 0; i < n ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
			}

			var formResults = form(formfields, 'Select an RSS Location', 'Select');

			var locationNum = "";
			
			if (formResults !== null) {
				locationNum = locationDir[findNumber(formResults[0],shortDir)];
				
				eprint('getLocationNumber:Selected entry=' + locationNum);
			}
			
			for (i = 0; i < n ; i += 1)
			{
				delete formfields[i];
			}
			delete formfields;
			
			return locationNum;
		}

		function deleteLocationNumber(locationDir,locationDefault)
		{
			var shortDir = nameDir(locationDir);
			
			var objDef = [['entries','RSS Locations:','popup',shortDir,extractName(locationDefault),'Select an RSS location to be deleted.']];

			var formfields = [];
			var i = 0;
			
			for (i = 0; i < 1 ; i += 1)
			{
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = objDef[i][4];
				formfields[i].description = objDef[i][5];
			}

			var formResults = form(formfields, 'Delete an RSS Location', 'Delete');

			var locationNum = "";
			
			if (formResults !== null) {
				locationNum = locationDir[findNumber(formResults[0],shortDir)];

				eprint('deleteLocationNumber:Selected entry=' + locationNum);
			}
			
			for (i = 0; i < 1 ; i += 1)
			{
				delete formfields[i];
			}
			delete formfields;
			
			return locationNum;
		}

		function addLocationData(locationDefault)
		{

			var objDef = [ ['firstKey','Description:','text',[''],'','Enter a description of this RSS location.'],
					   	   ['entry','Primary URL:','text',[''],'','Enter the primary URL (see the manual for a full explanation).\n\nIf the primary URL is not the (static) URL of an RSS feed, but is the URL of a web page, enter appropriate strings below.'],
						   ['guardStr','Guard String:','text',[''],'','Optionally, enter a guard string that precedes the prefixStr.'],
						   ['prefixStr','Prefix String:','text',[''],'','Enter a prefix string that immediately precedes the Start String.\n\nAt least one of the Prefix String or the Start String must be non-empty.'],
						   ['startStr','Start String:','text',[''],'','Enter the string that starts the RSS link.'],
						   ['endStr','End String:','text',[''],'','Enter the string that ends the RSS link.\n\nAt least one of the End String or the Suffix String must be non-empty.'],
						   ['suffixStr','Suffix String:','text',[''],'','Enter a suffix string that immediately follows the RSS link.'],
						   ['textMode','Text Mode:','checkbox',[''],'0','Check this box if the search strings relate to text that is to be found and displayed.'] ];

			var locationArr =  locationDefault.split(' | ');
			
			var strMap = [0, 1, 6, 4, 2, 3, 5, 7];	// Because the locationArr elements are not in the same order as the form fields.

			var formfields = [];
			var i = 0;
			
			for (i = 0; i < 7 ; i += 1)	// was 8 - textMode not available in this version
			{
				if (locationArr[strMap[i]] === undefined) { locationArr[strMap[i]] = ""; }
				
				formfields[i] = new FormField();
				formfields[i].name = objDef[i][0];
				formfields[i].title = objDef[i][1];
				formfields[i].type = objDef[i][2];
				formfields[i].option = objDef[i][3];
				formfields[i].defaultValue = locationArr[strMap[i]];
				formfields[i].description = objDef[i][5];
			}

			var formResults = form(formfields, 'Add a New RSS Location', 'Save');

			var locationName = "";	// Description
			var locationNum  = ""; // Primary URL
			
			var startStr  = "";
			var endStr    = "";
			var prefixStr = "";
			var suffixStr = "";
			var guardStr  = "";
			
			var frontStr  = "";
			var backStr   = "";
			
			var textMode  = "";
			
			var result    = "";
			
			if (formResults !== null)
			{
				locationName = stripBarAndComma(formResults[0]);
				locationNum  = substBarAndComma(formResults[1]);
				guardStr  = stripBarAndComma(formResults[2]);
				prefixStr = stripBarAndComma(formResults[3]);
				startStr  = stripBarAndComma(formResults[4]);
				endStr    = stripBarAndComma(formResults[5]);
				suffixStr = stripBarAndComma(formResults[6]);

				textMode = "0";	//textMode  = formResults[7];		// textMode not available in this version

				frontStr  = prefixStr + startStr;
				backStr   = endStr + suffixStr;
				

				if ((locationName !== "") && (locationNum !== "") && (frontStr === "") && (backStr === ""))		// static image URL
				{
					result = locationName + ' | ' + locationNum;
				}
				else if ((locationName !== "") && (locationNum !== "") && (frontStr !== "") && (backStr !== ""))	// dynamic image URL or text
				{
					result = locationName + ' | ' + locationNum + ' | ' + startStr + ' | ' + endStr + ' | ' + prefixStr + ' | ' + suffixStr + ' | ' + guardStr + ' | ' + textMode;
				}
				else
				{
					beep();
					alert('The data entered was incomplete and has been ignored.');
					eprint('addLocationData:The data entered was incomplete and has been ignored.');
				}
				eprint('addLocationData:' + result);
			}
			
			for (i = 0; i < 7 ; i += 1)	// was 8 - textMode not available in this version
			{
				delete formfields[i];
			}
			delete formfields;
			
			return result.replace(/\n/g,'');	// remove any newlines from the entered data
		}

		include('Resources/menu.js');
		
		// The following function is called when a menu item has been selected.

		function menuAction()			//	(i, data)
		{
			var i = this.i, data = this.data;
			
			eprint("Index:" + i + " Data:" + data);
		
			if (locationNum !== "")
			{
				chooseMenu.setTick(data);
				
				locationNum = locationDir[i];
				locationDefault = locationNum;
				sleep(50);
				preferences.savedDefaultPref.value = locationDefault;
				savePreferences();
				//writePlist("");
				nextNumber = findNumber(locationNum,locationDir);
				reloadRSS();
			}
		}

		function xtn(s)
		{
			var idx = s.lastIndexOf(".");
			if (idx >=0 )
			{
				var ext = s.substring(idx);
				if (ext.length > 7) { return ""; }
				if (ext.length > 1) { return ext; }
			}
			return "";
		}

		function isRSS(path)	// was (pathname)
		{
			eprint("------ isRSS() ------");

			if (! filesystem.itemExists(path) ) { return false; }

			if (systemPlatform == "macintosh")
			{
				var result = getFileInfo(path);
				var fileData = result.substr(path.length + 2);
				var item = fileData.split(" ",3);				// XML document text
				if (item.length < 3) { return false; }
				var stype = item[0];
				var itype = item[1];
				var dtype = item[2];
				
				eprint("isRSS:stype=" + stype + " itype=" + itype + " dtype=" + dtype);

				if ((stype == 'XML') && (itype == "document") && (dtype == "text")) { return true; }
			}
				result = filesystem.readFile(path);
			var header = result.substring(0, 512);
			if (header.indexOf("<rss")     >= 0) { return true; }
			if (header.indexOf("<channel") >= 0) { return true; }
			return false;
		}

		function replaceMacros(url)
		{
			if (url.indexOf('$TIME') >= 0)
			{
				url = url.replace(/\$TIME/g, String(new Date().getTime()));
			}
			return url;
		}

		function getPrimary(url, referer)
		{
			url = replaceMacros(url);
			lprint('getPrimary(' + url + ',' + referer + ')');
			return theURL(url, "", referer);
 		}
		
		
		function getImage(url, imageFile, referer)
		{
			lprint('getImage(' + url + ',' + imageFile + ',' + referer + ')');
			return theURL(url, imageFile, referer);
		}

		function getSecondary(imageEntry, data, startStr, endStr, prefixStr, suffixStr, guardStr, textMode)
		{
			eprint("------ getSecondary() ------");

			var fullurl  = "";
			var protocol = "";
			var host     = "";
			var path     = "";
			var params   = "";
			var site = "";

		  //var URL = /(\w+):\/\/\/?([\w\-\.\:]+)\/(\S*)/;

			var URL = /\s*(\w+:\/\/)?([\w\-\.\:]+)?(\/[^\s\?]*)?\??(\S*)/;

			var result = imageEntry.match(URL);
			if (result !== null)
			{
				fullurl  = result[0];					eprint("getSecondary:fullurl:  " + fullurl);
				protocol = result[1];
				host     = result[2];
				if (protocol === undefined)
				{
					if (host === undefined) { protocol = "file://"; } else { protocol = "http://"; }
				}

				if (host === undefined)
					{ host = ""; }						eprint("getSecondary:host:     " + host);
					
				path     = result[3];
				if (path === undefined)
					{ path = ""; }						eprint("getSecondary:path: " + path);

				params   = result[4];
				if (params === undefined)
					{ params = ""; }					eprint("getSecondary:params: " + params);

				site     = protocol + host;				eprint("getSecondary:site:     " + site);
			
				var guard   = escapeChar(guardStr);
				var start   = escapeChar(prefixStr + startStr);
				var	finish  = escapeChar(endStr + suffixStr);

				var lookFor = "";
				
				if (guardStr !== "") { lookFor += guard + '[.\\s\\S]*?'; }
				
				lookFor += start + '([.\\s\\S]*?)' + finish;
				
				var pattern = new RegExp(lookFor);
				
				eprint("getSecondary:Pattern=" + pattern);

				var selectArr = data.match(pattern);
				if (selectArr !== null)
				{
					var selectStr = startStr + selectArr[1] + endStr;
				}
				else
				{
					if (preferences.alertPref.value != "0")
					{
						beep();
						alert( 'Could not find secondary URL or requested data in ' + imageEntry);
						eprint('getSecondary:Could not find secondary URL or requested data in ' + imageEntry);
					}
					return "";
				}
						
				if (false)	// (textMode == "1")
				{
					return selectStr;
				}
				else
				{
					if (startStr.indexOf(site) === 0) { return selectStr; }
					
					if (startStr.indexOf("http://") === 0) { return selectStr; }
					if (startStr.indexOf("ftp://")  === 0) { return selectStr; }
					
					var sidx = startStr.indexOf("://");
					if ((sidx == 3) || (sidx == 4)) { return selectStr; }

					if (selectStr[0] == "/") { return site + selectStr; }

					var idx = imageEntry.lastIndexOf('/') + 1;
					if (idx != protocol.length)
					{
						return imageEntry.substring(0, idx) + selectStr;
					}
					else
					{
						return imageEntry + '/' + selectStr;
					}
				}
			}
			else
			{
				beep();
				alert('"' + imageEntry + '" is not a valid URL');
				lprint('getSecondary: "' + imageEntry + '" is not a valid URL');
				return "";
			}
		}

		function escapeChar(s) { return s.replace(/([\W])/g,"\\$1"); }	// Toasted Version!

		function LocalTime()
		{
			var d = new Date();
			return d.toString();
		}

		function takeAction(entry)
		{
			eprint("-----------takeAction-----------");
			lprint("takeAction:Action=" + entry);

			var result = "";
			
			var imageName  = extractName(entry);
			var imageEntry = extractNum(entry);
			var startStr   = extractStartStr(entry);
			var endStr     = extractEndStr(entry);
			var prefixStr  = extractPrefixStr(entry);
			var suffixStr  = extractSuffixStr(entry);
			var guardStr   = extractGuardStr(entry);
			var textMode   = extractTextMode(entry);

			var frontStr  = prefixStr + startStr;
			var backStr   = endStr + suffixStr;

			eprint("takeAction:guardStr= " + guardStr);
			eprint("takeAction:prefixStr=" + prefixStr);
			eprint("takeAction:startStr= " + startStr);
			eprint("takeAction:endStr=   " + endStr);
			eprint("takeAction:suffixStr=" + suffixStr);
			eprint("takeAction:textMode= " + textMode);
			
			Referer = "";

			if ((frontStr !== "")  && (backStr !== "")) // Secondary data defined - primary URL assumed to be that of a web page
			{
				var data = getPrimary(imageEntry, "");	// referer null
				
				if (data !== "")
				{
					Referer = imageEntry;
					imageEntry = getSecondary(imageEntry, data, startStr, endStr, prefixStr, suffixStr, guardStr, textMode);
					lprint("takeAction:Secondary=" + imageEntry);
					if (imageEntry === "") { return null; }
				}
				else
				{
					if (preferences.alertPref.value != "0")
					{
            				beep();
            				alert("Could not fetch " + imageEntry);
            				lprint("takeAction:Could not fetch " + imageEntry);
					}
					return null;
				}
			}

			var imageFile = system.widgetDataFolder + "/Downloads/" + widgetName + "-" + imageToggle;
			
			result = getImage(imageEntry, imageFile, Referer);
			return getImageDone(imageEntry, result);
		}

		function getImageDone(imageEntry, result)
		{
			if (result === "")
			{
				var imageFile = system.widgetDataFolder + "/Downloads/" + widgetName + "-" + imageToggle;
           		if ( isRSS(imageFile) )
           		{
 					imageToggle = (imageToggle + 1) % 1000000;
					return filesystem.readFile(imageFile);
             	}
            	else if (preferences.alertPref.value != "0")
            	{
            		beep();
            		alert(imageEntry +  " is not an RSS file.");
            		lprint(imageEntry + " is not an RRSS  file.");
            	}
            }
            else if (preferences.alertPref.value != "0")
            {
            	beep();
            	alert(result);
            	lprint("getImageDone:Result=" + result);
            }
            return null;
		}

		function cycleRSSLocation()
		{
			var max = locationDir.length;

			if ((preferences.cyclePref.value != "0") && (max > 1)) // find the next RSS location
			{
				nextNumber = (nextNumber + 1) % max;
				lprint('cycleRSSLocation:nextNumber=' + nextNumber);
				locationNum = locationDir[nextNumber];
				locationDefault = locationNum;
				preferences.savedDefaultPref.value = locationDefault;
				savePreferences();
					//writePlist(spawnKonFile);
				chooseMenu.setTick(nameDir(locationDir)[nextNumber]);
			}
		}

		function deleteDownloads()
		{
			lprint("------deleteDownloads()------");
			var imageDir = system.widgetDataFolder + "/Downloads";
			filesystem.remove(imageDir);
		}

		eprint('------ Setting Up Choose Location Menu ------');
		
		function makeButton()
		{
			quickMenu = new Image();
			quickMenu.window = main_window;
			quickMenu.alignment = 'left';
			quickMenu.hOffset = 0;
			quickMenu.vOffset = 0;
			quickMenu.src = 'Resources/menuImages/rss.png';
			quickMenu.opacity = 0;
			quickMenu.zOrder = 10;
			quickMenu.width  = 72;
			quickMenu.height = 20;
			quickMenu.onMouseDown = "chooseMenu.select();";
		}

		function showButtons()
		{
			if (preferences.rssMenuPref.value == "1")
			{
				if (rssMode) { quickMenu.fade(quickMenu.opacity, 255, 10); } else { quickMenu.fade(quickMenu.opacity, 128, 5); }
			}
			else
			{
				quickMenu.opacity = 0;
			}
		}

		function hideButtons()
		{
			if (preferences.rssMenuPref.value == "1")
			{
				if (rssMode) { quickMenu.fade(quickMenu.opacity,   0, 10); } else { quickMenu.fade(quickMenu.opacity,   0, 5); }
			}
			else
			{
				quickMenu.opacity = 0;
			}
		}

		makeButton();
		
		var menuStringsArray = nameDir(locationDir).join(',').split(',', gQuickMax);	// define the new array of menuStrings

		nextNumber = findNumber(locationNum,locationDir);
		var selectedString   = nameDir(locationDir)[nextNumber];  						// define the initially selected string, or set to ""
		var menuActionFunction   = menuAction;  										// define the name of the menuAction function - must be a string
		var menuImage = quickMenu;														// define the name of the image to be used as menu button

		var chooseMenu = new Menu(menuImage, menuStringsArray, selectedString, menuActionFunction); // call the menu constructor

		lprint('------ Starting environment code ------');

		var PATH = resolvePath(".");
		lprint('PATH=' + PATH);
		
		var ix = PATH.lastIndexOf("/");
		var folder = PATH.substring(ix+1); // "Contents" or Something else
		lprint('folder=' + folder);

		if (folder == "Contents"){					// this is an original widget
			resPath = PATH;
			var idx = PATH.lastIndexOf(".widget/Contents");
			var temp = PATH.substring(0,idx);
			idx = temp.lastIndexOf("/");
			widgetName = temp.substring(idx+1);
		}
		else { alert('PATH=' + PATH); closeWidget(); }

		//if (preferences.outputFolderPref.value === "") preferences.outputFolderPref.value = system.userDocumentsFolder;

		if (preferences.backupFolderPref.value === "") { preferences.backupFolderPref.value = system.userDocumentsFolder; }

		var sem = system.event.modifiers;	// capslock forces Special Startup Mode
		
		if ((filesystem.itemExists(system.widgetDataFolder + "/debug.txt")) || capslockKeyDown(sem))
		{
			lprint("Entered Special Startup Mode");

			while (alert(widgetName + ": Would you like to delete any URLs.", "Yes", "No") == "1")
			{
				wrenchMouseUp();
				var max = locationDir.length;
				nextNumber = (nextNumber + 1) % max;
				locationNum = locationDir[nextNumber];
				locationDefault = locationNum;
				preferences.savedDefaultPref.value = locationDefault;
				savePreferences();
			}
		}
		
		if (filesystem.itemExists(system.widgetDataFolder + "/Downloads"))
		{
			filesystem.remove(system.widgetDataFolder + "/Downloads");
		}
		filesystem.createDirectory(system.widgetDataFolder + "/Downloads");

		ledDisplay();	// do it !